﻿using System;
using GameKnight.Core;

namespace GameKnight
{
	
	namespace GameBoy
	{
	
		public partial class Processor : IProcessor
		{
			
			protected partial class Opcode
			{
				
				public static int BIT( Processor Processor, Opcode Opcode )
				{
					Processor.NegativeFlag = false;
					Processor.HalfCarryFlag = true;
					Processor.ZeroFlag = ( ( Processor.GetRegisterValue( Opcode.Value & 0x07 ) & ( 1 << ( ( Opcode.Value >> 3 ) & 0x07 ) ) ) == 0 );
					return 0;
				}
				
				public static int RES( Processor Processor, Opcode Opcode )
				{
					int RegisterIndex = ( Opcode.Value & 0x07 );
					byte Value = Processor.GetRegisterValue( RegisterIndex );
					Value &= (byte)( ~( 1 << ( ( Opcode.Value >> 3 ) & 0x07 ) ) );
					Processor.SetRegisterValue( RegisterIndex, Value );		
					return 0;
				}
				
				public static int SET( Processor Processor, Opcode Opcode )
				{
					int RegisterIndex = ( Opcode.Value & 0x07 );
					byte Value = Processor.GetRegisterValue( RegisterIndex );
					Value |= (byte)( 1 << ( ( Opcode.Value >> 3 ) & 0x07 ) );		
					Processor.SetRegisterValue( RegisterIndex, Value );		
					return 0;
				}
				
			}
			
		}
		
	}
	
}
	
	
