using System;
using GameKnight.Core;

namespace GameKnight
{
	
	namespace GameBoy
	{

		public partial class Register : IRegister
		{
			
			public sealed class IE : IRegister
			{

				private readonly Register.IF IF = null;
				
				public byte Value = 0;
					
				public IE( IConsole Console )
				{
					this.IF = Console.GetRegister<Register.IF>();
					return;
				}

				public byte this[int Address]
				{
					get
					{
						return Value;
					}
					set
					{
						Value = value;
						IF.Value &= value;
						//System.Diagnostics.Debug.Print( String.Format( "{0:X2}", Value ) );
						return;
					}
				}
				
			}
			
		}

	}
	
}


