﻿using System;
using Drawing = System.Drawing;
using Forms = System.Windows.Forms;
using GameKnight.Core;

namespace GameKnight.Win32
{

//	public partial class Application : IInterface
//	{
		
//		private partial class ControllerDialog : Forms.Form
//		{
			
			public sealed class ControllerTabPage : Forms.TabPage
			{
			
				public ControllerTabPage( Forms.TabControl TabControl, InputDevice InputDevice, IController Controller ) : base()
				{
					this.Text = Controller.Name;
					for( int i = 0; i < 2; i++ )
					{
						for( int j = 0; j < ( Controller.ControlArray.Length / 2 ); j++ )
						{
							IControl CurrentControl = Controller.ControlArray[j+(i*(Controller.ControlArray.Length/2))];
							ControlPanel ControlPanel = new ControlPanel( InputDevice, CurrentControl );
							ControlPanel.Left = ( 8 + ( i * ( TabControl.ClientSize.Width / 2 ) ) );
							ControlPanel.Top = ( ControlPanel.Height + ( j * ControlPanel.Height * 2 ) );
							this.Controls.Add( ControlPanel );
						}
					}
					return;
				}
				
			}
			
		}
		
//	}
	
//}

