using System;

namespace GameKnight.Core
{

	public interface IController
	{
		
		IConsole Console { get; }
		
		IControl[] ControlArray { get; }

		bool Enabled { get; set; }

		string Name { get; }
		
		int this[IControl Control] { get; set; }
		
	}
	
}
